<?php

/**
 * This project has been generated by worker generator
 * has been made by fahmi sulaiman
 * sulaimanfahmi@gmail.com
 * check out my github @dekaulitz
 */

namespace App\Http\Models;

use App\Http\Base\BaseModel;
use Carbon\Carbon;
use App\Http\Providers\iam\core\model\OracleOCIConnector;

class StgpelniscmrcvtrxintModel extends BaseModel
{
    /**
     * table name from database
     */
    protected $table = "stg_pelni_scm_rcv_trx_int";

    /**
     *   alias table for relation issues
     */
    protected $aliasTable = "stgpelniscmrcvtrxint";

    /**
     * primary key from table remember eloquent doesnt support composite primary key
     */
    protected $primaryKey = "id";
    /**
     * check the incrementing boolean if the incrementing from database is false then the value is false by default
     */
    // public $incrementing = false;
    /**
     * fillable property for eloquent attribute cast
     */
    protected $fillable = [
        "transaction_number",
        "item_id",
        "item_segment1",
        "transaction_date",
        "quantity",
        "ship_to_location_code",
        "item_num",
        "last_update_date", // di oracle dimasukkin k CREATION_DATE
        "interface_transaction_id",
        "creation_date",
        "transaction_type",
        "processing_status_code",
        "transaction_status_code",
        "processing_mode_code",
        "attribute2",
        "flagsync",
        "voyage_call",
        "total_line"

    ];

    public static function prepareSaveToOracle()
    {
        $start = 0;
        $limit = 100;
        $nRepeat = 0;
        (new LogsyncoracleModel)->setLogSync("Item Penerimaan Barang PO", Carbon::now()->toDateTimeString(), "", "start");
        do {
            $stagings = (new StgpelniscmrcvtrxintModel())->getQuery()
                ->whereNull("stgpelniscmrcvtrxint.flagsync")
                ->orWhere("stgpelniscmrcvtrxint.flagsync", "<", 1)
                ->offset($start)->limit($limit)->get();
            foreach ($stagings as $stag) {
                if ((new StgpelniscmrcvtrxintModel())->saveToOracle($stag)) {
                    $updateStg = self::find($stag->id);
                    $updateStg->flagsync = 1;
                    $updateStg->update();
                }
            }
            if (count($stagings) < $limit) {
                $repeat = false;
            } else {
                $repeat = true;
                $start += $limit;
            }
            if (count($stagings) > 0) {
                $nRepeat++;
            }
        } while ($repeat);
        if ($nRepeat > 0) {
            (new LogsyncoracleModel)->setLogSync("Item Penerimaan Barang PO", Carbon::now()->toDateTimeString(), "", "success");
        }
    }


    public function saveToOracle($data)
    {
        $query = "INSERT INTO pelni_scm_rcv_trx_int 
            (TRANSACTION_NUMBER,ITEM_ID,TRANSACTION_DATE,QUANTITY,SHIP_TO_LOCATION_CODE,ITEM_NUM,CREATION_DATE,INTERFACE_TRANSACTION_ID
,TRANSACTION_TYPE,PROCESSING_STATUS_CODE,TRANSACTION_STATUS_CODE,PROCESSING_MODE_CODE,ATTRIBUTE2, VOYAGE_CALL, TOTAL_LINE) 
VALUES (
'" . $data->transaction_number . "','" . $data->item_id . "',TO_DATE('" . Carbon::parse($data->transaction_date)->format("Y/m/d H:i:s") . "', 'yyyy/mm/dd hh24:mi:ss'),
'" . $data->quantity . "',
'" . $data->ship_to_location_code . "',
'" . $data->item_num . "',
TO_DATE('" . Carbon::parse($data->creation_date)->format("Y-m-d") . "', 'yyyy-mm-dd'),
'" . $data->interface_transaction_id . "',
'" . $data->transaction_type . "',
'" . $data->processing_status_code . "','" . $data->transaction_status_code . "',
'" . $data->processing_mode_code . "','" . $data->attribute2 . "', '" . $data->voyage_call . "', '" . $data->total_line . "')";
        try {
            $oracleOCI = new OracleOCIConnector();
            $oracleOCI->getConnection()->insert($query)->execute();
            (new LogsyncoracleModel)->setLogSync("Item Penerimaan Barang PO : ".$data->transaction_number." - ".$data->item_segment1, Carbon::now()->toDateTimeString(), "", "posted");
            $oracleOCI->closeConnection();
            return true;
        } catch (\Exception $e) {
            (new LogsyncoracleModel)->setLogSync("Item Penerimaan Barang PO : ".$data->transaction_number." - ".$data->item_segment1, Carbon::now()->toDateTimeString(), $e->getMessage(), "failed");
            return false;
        }
    }
}